#include "testlib.h"

using namespace std;

const long long MAXN[] = {(int)1e6, (int)1e6, (long long)1e18, (int)1e5, (int)1e3, (int)1e5};

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);
    int group = validator.group() == "" ? 5 : validator.group()[0] - '0';
    cerr << group << endl;
    if (group < 3) {
        long long l = inf.readLong(1ll, MAXN[group], "l~");
        inf.readEoln();
        inf.readLong(l, MAXN[group], "r~");
    } else {
        string pattern = format("[1][0]{%d,%d}", 0, MAXN[group]);
        if (group != 3) {
            pattern += format("|([1-9][0-9]{%d,%d})", 0, MAXN[group] - 1);
        }
        cerr << pattern << endl;
        string l = inf.readToken(pattern, "l~");
        if (group == 3) {
            ensuref(l == "1", "l == 1");
        }
        inf.readEoln();
        string r = inf.readToken(pattern, "r~");
        ensuref(l.size() < r.size() || (l.size() == r.size() && l <= r), "l <= r");
    }
    inf.readEoln();
    inf.readEof();
    return 0;    
}
