//  Nikita Golikov, 2024

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif

template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, k;
  cin >> n >> k;
  vector<int> a(n);
  for (auto& x : a) {
    cin >> x;
  }
  ll ans = 0;
  for (int mask = 0; mask < (1 << (n - 1)); ++mask) {
    if (__builtin_popcount(mask) + 1 != k) {
      continue;
    }
    ll maxSum = 0;
    ll minSum = 1e18;
    ll sum = 0;
    for (int i = 0; i < n; ++i) {
      sum += a[i];
      if (i == n - 1 || mask >> i & 1) {
        smax(maxSum, sum);
        smin(minSum, sum);
        sum = 0;
      }
    }
    smax(ans, maxSum - minSum);
  }
  cout << ans << "\n";

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
