//  Nikita Golikov, 2024

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif

template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, k;
  cin >> n >> k;
  vector<int> a(n);
  for (auto& x : a) {
    cin >> x;
  }
  vector<ll> pref(n + 1);
  for (int i = 0; i < n; ++i) {
    pref[i + 1] = pref[i] + a[i];
  }
  ll sum = pref[n];
  if (k == 2) {
    cout << sum - 2 * min(a[0], a[n - 1]) << "\n";
    return 0;
  }
  ll ans = 0;
  //  1, 1, x
  smax(ans, sum - a[0] - a[1] - a[0]);
  //  1, x, 1
  smax(ans, sum - a[0] - a[n - 1] - a[0]);
  //  1, x, 1
  smax(ans, sum - a[0] - a[n - 1] - a[n - 1]);
  //  x, 1, 1
  smax(ans, sum - a[n - 1] - a[n - 2] - a[n - 1]);
  for (int pos = 1; pos < n - 1; ++pos) {
    smax(ans, max(pref[pos], sum - pref[pos + 1]) - a[pos]);
  }
  cout << ans << "\n";

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
