//  Nikita Golikov, 2024
 
#include <bits/stdc++.h>
 
using namespace std;
 
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
 
#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif
 
template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}
 
template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
 
  int n, k;
  cin >> n >> k;
  vector<int> a(n);
  for (auto& x : a) {
    cin >> x;
  }
  ll const INF = 1e18;
  vector dp(2, vector(2, vector<ll>(n + 1, -INF)));
  dp[0][0][0] = 0;
  for (int iter = 0; iter < k; ++iter) {
    for (int i = n; i >= 0; --i) {
      ll sum = 0;
      ll val[2][2]{};
      for (int x = 0; x < 2; ++x) {
        for (int y = 0; y < 2; ++y) {
          val[x][y] = dp[x][y][i];
          dp[x][y][i] = -INF;
        }
      }
      for (int j = i + 1; j <= n; ++j) {
        sum += a[j - 1];
        for (int x = 0; x < 2; ++x) {
          for (int y = 0; y < 2; ++y) {
            smax(dp[x][y][j], val[x][y]);
            if (!x) {
              smax(dp[1][y][j], val[x][y] + sum);
            }
            if (!y) {
              smax(dp[x][1][j], val[x][y] - sum);
            }
          }
        }
      }
    }
  }
  cout << dp[1][1][n] << "\n";
 
#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
