//  Nikita Golikov, 2024
 
#include <bits/stdc++.h>
 
using namespace std;
 
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
 
#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif
 
template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}
 
template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}
 
int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
 
  int n, k;
  cin >> n >> k;
  vector<int> a(n);
  for (auto& x : a) {
    cin >> x;
  }

  ll ans = 0;
  auto solve = [&] {
    vector<ll> pref(n + 1);
    for (int i = 0; i < n; ++i) {
      pref[i + 1] = pref[i] + a[i];
    }
    for (int pos = 0; pos < n; ++pos) {
      for (int L = 0; L < pos; ++L) {
        for (int R = L; R < pos; ++R) {
          int minSegments = 2 + (L > 0) + (R + 1 < pos) + (pos + 1 < n);
          int maxSegments = n - (R - L + 1) + 1;
          if (minSegments <= k && k <= maxSegments) {
            smax(ans, pref[R + 1] - pref[L] - a[pos]);
          }
        }
      }
    }
  };
  solve();
  reverse(a.begin(), a.end());
  solve();
  cout << ans << "\n";
 
#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
