//  Nikita Golikov, 2024
 
#include <bits/stdc++.h>
 
using namespace std;
 
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
 
#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif
 
template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}
 
template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
 
  int n, k;
  cin >> n >> k;
  vector<int> a(n);
  for (auto& x : a) {
    cin >> x;
  }
  vector<ll> pref(n + 1);
  for (int i = 0; i < n; ++i) {
    pref[i + 1] = pref[i] + a[i];
  }
  ll const INF = 1e18;
  vector dp(2, vector(2, vector<ll>(n + 1, -INF)));
  dp[0][0][0] = 0;
  for (int iter = 0; iter < k; ++iter) {
    ll upd[3][3];
    for (int x = 0; x < 3; ++x) {
      for (int y = 0; y < 3; ++y) {
        upd[x][y] = -INF;
      }
    }
    for (int i = 0; i <= n; ++i) {
      ll ndp[2][2];
      for (int x = 0; x < 2; ++x) {
        for (int y = 0; y < 2; ++y) {
          ndp[x][y] = upd[x][y];
          if (x == 1 && upd[2][y] != -INF) {
            smax(ndp[x][y], upd[2][y] + pref[i]);
          }
          if (y == 1 && upd[x][2] != -INF) {
            smax(ndp[x][y], upd[x][2] - pref[i]);
          }
        }
      }
      for (int x = 0; x < 2; ++x) {
        for (int y = 0; y < 2; ++y) {
          if (dp[x][y][i] == -INF) {
            continue;
          }
          smax(upd[x][y], dp[x][y][i]);
          if (x == 0) {
            smax(upd[2][y], dp[x][y][i] - pref[i]);
          }
          if (y == 0) {
            smax(upd[x][2], dp[x][y][i] + pref[i]);
          }
        }
      }
      for (int x = 0; x < 2; ++x) {
        for (int y = 0; y < 2; ++y) {
          dp[x][y][i] = ndp[x][y];
        }
      }
    }
  }
  cout << dp[1][1][n] << "\n";
 
#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
