//  Nikita Golikov, 2024
 
#include <bits/stdc++.h>
 
using namespace std;
 
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
 
#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif
 
template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}
 
template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}
 
int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
 
  int n, k;
  cin >> n >> k;
  vector<int> a(n);
  for (auto& x : a) {
    cin >> x;
  }

  ll ans = 0;
  auto solve = [&] {
    vector<ll> pref(n + 1);
    for (int i = 0; i < n; ++i) {
      pref[i + 1] = pref[i] + a[i];
    }
    vector<ll> prefMin(n + 1, 1e18);
    for (int i = 0; i < n; ++i) {
      prefMin[i + 1] = min<ll>(prefMin[i], a[i]);
    }
    vector<ll> suffMin(n + 1, 1e18);
    for (int i = n - 1; i >= 0; --i) {
      suffMin[i] = min<ll>(suffMin[i + 1], a[i]);
    }
    int L = n + 1 - k;
    for (int start = 0; start + L <= n; ++start) {
      smax(ans, pref[start + L] - pref[start] - min(prefMin[start], suffMin[start + L]));
    }
    /*//  max is prefix + minimum after
    for (int len = 1; len <= n - 1; ++len) {
      int minCnt = 2 + (len < n - 1);
      int maxCnt = 2 + (n - (len + 1));
      if (k >= minCnt && k <= maxCnt) {
        smax(ans, pref[len] - a[len]);
      }
    }*/
  };

  solve();
  reverse(a.begin(), a.end());
  solve();
  cout << ans << "\n";
 
#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
