//  Nikita Golikov, 2024
 
#include <bits/stdc++.h>
 
using namespace std;
 
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
 
#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif
 
template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}
 
template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}
 
int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
 
  int n, k;
  cin >> n >> k;
  vector<int> a(n);
  for (auto& x : a) {
    cin >> x;
  }
  vector<ll> pref(n + 1);
  for (int i = 0; i < n; ++i) {
    pref[i + 1] = pref[i] + a[i];
  }
  int const B = 10;

  auto FindMin = [&](int l, int r) {
    return *min_element(a.begin() + l, a.begin() + r);
  };
  ll ans = 0;
  auto check = [&](int len) {
    if (len <= 0 || len > n) {
      return;
    }
    for (int start = 0; start + len <= n; ++start) {
      int end = start + len;
      ll sum = pref[end] - pref[start];
      auto checkSolo = [&](int pos, int L1, int R1, int L2, int R2) {
        int minSegments = 1 + (R1 > L1) + 1 + (R2 > L2);
        int maxSegments = n - len + 1;
        if (k >= minSegments && k <= maxSegments) {
          if (smax(ans, sum - a[pos])) {
            // cerr << start << " " << end << endl;
            // for (int i = start; i < end; ++i) {
            //   cerr << a[i] << " ";
            // }
            // cerr << endl;
          }
        }
      };
      auto checkInside = [&](int L1, int R1, int L2, int R2) {
        if (L1 >= R1) {
          return;
        }
        int minSegments = 4 + (R2 > L2);
        int maxSegments = n - len + 1;
        if (k >= minSegments && k <= maxSegments) {
          if (smax(ans, sum - FindMin(L1, R1))) {
            // cerr << start << " " << end << endl;
            // for (int i = start; i < end; ++i) {
            //   cerr << a[i] << " ";
            // }
            // cerr << endl;
          }
        }
      };
      if (start > 0) {
        checkSolo(0, 1, start, end, n);
        checkSolo(start - 1, 0, start - 1, end, n);
      }
      if (end < n) {
        checkSolo(end, end + 1, n, 0, start);
        checkSolo(n - 1, end, n - 1, 0, start);
      }
      checkInside(1, start - 1, end, n);
      checkInside(end + 1, n - 1, 0, start);
    }
  };

  for (int len = n - k - B; len <= n - k + B; ++len) {
    check(len);
  }
  cout << ans << "\n";
 
#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
